#ifndef _ASM_SW_64_TOPOLOGY_H
#define _ASM_SW_64_TOPOLOGY_H

#include <linux/smp.h>
#include <linux/threads.h>
#include <asm/machvec.h>
#include <linux/cpumask.h>
#ifdef CONFIG_NUMA
static inline int cpu_to_node(int cpu)
{
	int node;

	if (!sw_mv.cpuid_to_nid)
		return 0;

	node = sw_mv.cpuid_to_nid(cpu);

#ifdef DEBUG_NUMA
	BUG_ON(node < 0);
#endif

	return node;
}
extern const struct cpumask *cpumask_of_node(int node);
#define parent_node(node) (node)
#define cpumask_of_pcibus(bus)	(cpu_online_mask)
#define pcibus_to_node(bus) 0
#endif /* !CONFIG_NUMA */
# include <asm-generic/topology.h>

#endif /* _ASM_SW_64_TOPOLOGY_H */
